/*=============================================================================


    File:       opeq.pl

    Authors:    Frank Richter, Ulm University, Germany
                (based on and inspired by the confluence checker
				written by Johannes Langbein)

    Date:       26-06-2014
    
    Version:    1.0 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

=============================================================================*/

/*============================== consult 1 ====================================

This file is used to consult a test-program with a given query. This is put into
a separate module so that two different programs can be consulted without any 
conflicts that would caused by redefining the CHR constraints.


Predicates in this file:
========================

    consult_file1/4    Consults a file, calls it with a given query and returns the result.
    
    
==============================================================================*/

:- module(consult1, [consult_file1/4]).
:- use_module(conflcheckhelp, 	[findall_chr_constraints/2]).

% consult_file1(+File1,+H1,+V, -Result)
%
% This predicate consults the test file given by File2 and calls the query H1.
% Then findall_chr_constraints is called with the global variables V1 that belong to
% the called state to return the final state of the computation in Result1.
% Finally the test program is consulted again to clear the constraint store.	
							
consult_file1(File1,H1,V1,Result1):-
    consult(File1),
    call(H1), 
    findall_chr_constraints(V1, Result1), 
	consult(File1).