/*=============================================================================


    File:       opeq.pl

    Authors:    Frank Richter, Ulm University, Germany
                (based on and inspired by the confluence checker
				written by Johannes Langbein)

    Date:       26-06-2014
    
    Version:    1.0 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

=============================================================================*/

/*============================== consult 2 ====================================

This file is used to consult a test-program with a given query. This is put into
a separate module so that two different programs can be consulted without any 
conflicts that would caused by redefining the CHR constraints.


Predicates in this file:
========================

    consult_file2/4    Consults a file, calls it with a given query and returns the result.
    
    
==============================================================================*/

:- module(consult2, [consult_file2/4]).
:- use_module(conflcheckhelp, 	[findall_chr_constraints/2]).

% consult_file2(+File2,+H2,+V2, -Result)
%
% This predicate consults the test file given by File2 and calls the query H2.
% Then findall_chr_constraints is called with the global variables V2 that belong to
% the called state to return the final state of the computation in Result2.
% Finally the test program is consulted again to clear the constraint store.						
							
consult_file2(File2,H2,V2,Result2):-
    consult(File2),
    call(H2), !,
    findall_chr_constraints(V2, Result2), !,
	consult(File2).